#include "ConfigMgr.h"

//CConfigMgr* CConfigMgr::m_shInstance= NULL;

CConfigMgr::CConfigMgr()
{
	char szTmp[MAX_PATH];
	m_mapData[CFG_MODE] = MODE_DEFAULT;
	m_mapData[CFG_LRCCODE] = LRC_CODE;
	m_mapData[CFG_ENVCODE] = ENV_CODE;
	m_mapData[CFG_LRCLIGHT] = "3";
	m_mapData[CFG_LRCDIR] = "";
	m_mapData[CFG_VOLUME] = "80";
	m_mapData[CFG_FILEDIR] = "/";
	m_mapData[CFG_PLAYMODE] = "3";
	m_mapData[CFG_KEYMODE] = "0";
	//blank means all ...
	m_mapData[CFG_MUSICTYPE] = "|mp3|wma|wmv|flv|mp4|rm|rmvb|";
	m_mapData[CFG_LISTTYPE] = "|lst|";
	m_mapData[CFG_PLUSDIR] = PLUGIN_DIR;
	//key map ...
	m_mapData[VKEY_NOUSE] = "";
	m_mapData[VKEY_QUIT] = "|[q]|";
	m_mapData[VKEY_REFRESH] = "|[f]|";
	m_mapData[VKEY_MODE] = "|[d]|";
	m_mapData[VKEY_LIST] = "|[l]|";
	m_mapData[VKEY_LRC] = "|[r]|";
	m_mapData[VKEY_PLUS] = "|[g]|";
	m_mapData[VKEY_ABOUT] = "|[a]|";
	m_mapData[VKEY_PAUSE] = "|[p]|";
	m_mapData[VKEY_STOP] = "|[s]|";
	m_mapData[VKEY_MUTE] = "|[m]|";
	m_mapData[VKEY_ADD] = "|331|[=]|";
	m_mapData[VKEY_DEL] = "|330|[-]|";
	m_mapData[VKEY_CLR] = "|[e]|";
	m_mapData[VKEY_PREV] = "|[,]|";
	m_mapData[VKEY_NEXT] = "|[.]|";
	m_mapData[VKEY_VOLUP] = "|93|";
	m_mapData[VKEY_VOLDN] = "|91|";
	m_mapData[VKEY_BLANK] = "|[ ]|";
	m_mapData[VKEY_ENTER] = "|10|";
	m_mapData[VKEY_ESC] = "|27|";
	m_mapData[VKEY_KEYMODE] = "|[k]|";

	//end
	sprintf(szTmp, "%s%scmmusic.cfg", getenv("HOME"), APP_DIR);
	Load(szTmp);
	m_mapBackup = m_mapData;
}

CConfigMgr::~CConfigMgr()
{
	Save();
}

void CConfigMgr::Save()
{
	if (!m_strPath.empty() && IsChanged())
	{
		FILE* pf = fopen(m_strPath.c_str(), "w");
		if (pf)
		{
			std::map<std::string,std::string>::iterator iter;
			for (iter = m_mapData.begin(); iter!=m_mapData.end(); ++iter)
			{
				fprintf(pf, "%s=%s\n", iter->first.c_str(),
						iter->second.c_str());
			}
			fclose(pf);
		}
	}
}

void CConfigMgr::Load(const char* lpszFile)
{
	std::string strTmp;
	std::ifstream infile(lpszFile);
	m_strPath = lpszFile;
	const char* lpszStr = 0;
	const char* lpszData = 0;
	std::string strArg,strData;
	while (getline(infile, strTmp))
	{
		if (strTmp.substr(0,1) == "#")	// rem ...
		{
			continue;
		}
		if ((lpszStr = strTmp.c_str()) && (lpszData = strchr(lpszStr, '=')))
		{
			int nTmp = lpszData - lpszStr;
			strArg = strTmp.substr(0, nTmp);
			strData = lpszData ? (lpszData+1) : "";
			m_mapData[strArg] = strData;
		}
	}
	std::map<std::string,std::string>::iterator iter;
	for (iter = m_mapData.begin(); iter!=m_mapData.end(); ++iter)
	{
		strArg = iter->first;
		if (strArg.length() > 4 && strArg.substr(0, 4) == "key_")
		{
			strData = iter->second;
			// key parse ...
			int nKey = -1;
			char szTmp[16];
			size_t nStart = 0;
			size_t LPos = 0;
			size_t RPos = 0;
			do
			{
				LPos = strData.find('[', nStart);
				RPos = strData.find(']', nStart);
				if (2==(RPos-LPos))
				{
					char ch = *strData.substr(LPos+1,1).c_str();
					nKey = ch;
					sprintf(szTmp, "%d", nKey);
					strData.replace(LPos, 3, szTmp, strlen(szTmp));
				}
				nStart = RPos > LPos ? RPos : LPos;
				nStart ++;
			} while (std::string::npos != LPos && std::string::npos != RPos);
			m_mapData[strArg] = strData;
		}
	}

}

bool CConfigMgr::IsKey(const char* lpszArg, int nKey)
{
	// format : |[x]|234|
	char szTmp[32];
	sprintf(szTmp, "|%d|", nKey);
	std::map<std::string,std::string>::iterator iter;
	iter = m_mapData.find(lpszArg);
	if (m_mapData.end()!=iter)
	{
		std::string strData = iter->second;
		if (std::string::npos != strData.find(szTmp))
		{
			return true;
		}
	}
	return false;
}

std::string CConfigMgr::GetCfgStr(const char* lpszArg)
{
	std::string strRet;
	std::map<std::string,std::string>::iterator iter;
	iter = m_mapData.find(lpszArg);
	if (m_mapData.end()!=iter)
	{
		strRet = iter->second;
	}
	return strRet;
}

int CConfigMgr::GetCfgInt(const char* lpszArg)
{
	return atoi(GetCfgStr(lpszArg).c_str());
}

void CConfigMgr::SetCfg(const char* lpszArg, const char* lpszStr)
{
	std::map<std::string,std::string>::iterator iter;
	iter = m_mapData.find(lpszArg);
	if (m_mapData.end()!=iter)
	{
		m_mapData[lpszArg] = lpszStr;
	}
}

void CConfigMgr::SetCfg(const char* lpszArg, int nData)
{
	std::map<std::string,std::string>::iterator iter;
	iter = m_mapData.find(lpszArg);
	if (m_mapData.end()!=iter)
	{
		char szTmp[128];
		sprintf(szTmp, "%d", nData);
		m_mapData[lpszArg] = szTmp;
	}
}

bool CConfigMgr::IsChanged()
{
	std::map<std::string,std::string>::iterator iter;
	std::string strArg;
	for (iter = m_mapBackup.begin(); iter!=m_mapBackup.end(); ++iter)
	{
		strArg = iter->first;
		if (m_mapData.end() != m_mapData.find(strArg))
		{
			if (m_mapData[strArg] != m_mapBackup[strArg])
			{
				return true;
			}
		}
	}
	return false;
}

