
#include "Helper.h"

CHelper* CHelper::m_shInstance= NULL;

CHelper::CHelper()
{
	m_strMode = GetCfgStr(CFG_MODE);
	m_strLrcM = GetCfgStr(CFG_LRCCODE);
	m_strEnvM = GetCfgStr(CFG_ENVCODE);
}

CHelper::~CHelper()
{
}

CHelper* CHelper::GetInstance()
{
	if (!m_shInstance)
	{
		m_shInstance = new CHelper;
	}
	return m_shInstance;
}

std::string CHelper::GetPath(const char* lpszFile)
{
	if (m_strAppPath.empty())
	{
		m_strAppPath = getenv("HOME");
		m_strAppPath += APP_DIR;
	}
	std::string strRet = m_strAppPath;
	if (lpszFile)
	{
		strRet += lpszFile;
	}
	return strRet;
}

void CHelper::Log(const char* lpszStr,...)
{
	FILE* pf = fopen("Dbg.log","a+");
	if (pf)
	{
		va_list   arg;   
		va_start(arg,   lpszStr); 
		vfprintf(pf,lpszStr,arg);
		va_end(arg); 
		fclose(pf);
	}
}

int CHelper::Lrc2Env(const char *inbuf, char *outbuf)
{
	if (m_strEnvM == m_strLrcM)
	{
		return -1;
	}
	return ConvertCode(m_strLrcM.c_str(),m_strEnvM.c_str(),inbuf,outbuf);
}

int CHelper::ConvertCode(const char *from_charset, const char *to_charset,
		const char *inbuf, char *outbuf)
{
	size_t inlen = strlen(inbuf);
	size_t outlen = 2048;

	iconv_t cd;
	cd = iconv_open(to_charset, from_charset);
	if (cd == 0)
	{
		return -1;
	}

	if (iconv(cd,
#ifndef _WIN32
			(char**)
#endif
			&inbuf, &inlen, &outbuf, &outlen) == (size_t) -1)
	{
		return -1;
	}
	iconv_close(cd);
	return outlen;
}

std::string CHelper::ConvertCode(const char *from_charset,
		const char *to_charset, const char* lpszStr)
{
	std::string str;
	int nLen = strlen(lpszStr);
	if (nLen > 0)
	{
		char* pszStr = new char[nLen*2];
		int nRet = ConvertCode(from_charset, to_charset, lpszStr, pszStr);
		if (nRet != -1)
		{
			str = pszStr;
		}
		delete[] pszStr;
	}

	return str;
}
