/*! @file
********************************************************************************
<PRE>
Module       : CMMusic
file	     : 
function	 : 
author       : fedorawang
ver	         : v1.5
--------------------------------------------------------------------------------
Copyright    : GPL(General Public License)
--------------------------------------------------------------------------------
</PRE>
*******************************************************************************/
#ifndef IMANAGER_H_
#define IMANAGER_H_

#include "commdef.h"

class IManager
{
public:
	virtual ~IManager(){};
	virtual int OnMsg(const char* lpszMsg,WPARAM wParam,LPARAM lParam) = 0;
};

class CManager : public IManager
{
public:
	CManager():m_pMgr(NULL)
	{
		
	}
	virtual int OnMsg(const char* lpszMsg,WPARAM wParam,LPARAM lParam){return -1;};
	virtual int SendMgrMsg(const char* lpszMsg,WPARAM wParam,LPARAM lParam)
	{
		if (m_pMgr)
		{
			return m_pMgr->OnMsg(lpszMsg,wParam,lParam);
		}
		return -1;
	}
	virtual void SetMgr(IManager* pMgr)
	{
		m_pMgr = pMgr;
	}
protected:
	IManager* m_pMgr;
};

#endif /*IMANAGER_H_*/
