#include "LrcMgr.h"

CLrcMgr::CLrcMgr()
{
}

CLrcMgr::~CLrcMgr()
{
}

void CLrcMgr::EraseChar(std::string& str,char cChr)
{
	size_t nPos;
	while ((nPos = str.find(cChr)) != std::string::npos)
	{
		str.erase(nPos,1);
	}
}

bool CLrcMgr::LoadFile(const char* lpszFile)
{
	m_vctLrc.clear();
	std::ifstream infile(lpszFile);
	std::string strTmp, strItem;
	char buffUTF8[2048];
	
	while (getline(infile, strTmp))
	{
		float fPos;
		std::string strPos;
		std::string strPosTmp;
		std::vector<float> vctfPos;
		const char* lpszStr = strTmp.c_str();
		while(strchr(lpszStr,'[') == lpszStr && 
				strchr(lpszStr,']') == (lpszStr + 9))
		{
			strPosTmp = lpszStr;
			strPos = strPosTmp.substr(1,8);
			fPos = GetPos(strPos.c_str());
			vctfPos.push_back(fPos);
			lpszStr += 10;
		}
		if (0==vctfPos.size())
		{
			lpszStr = strTmp.c_str();
			while(strchr(lpszStr,'[') == lpszStr && 
					strchr(lpszStr,']') == (lpszStr + 6))
			{
				strPosTmp = lpszStr;
				strPos = strPosTmp.substr(1,5);
				fPos = GetPos(strPos.c_str());
				vctfPos.push_back(fPos);
				lpszStr += 7;
			}
		}
		if (0==vctfPos.size())
		{
			continue;
		}
		memset(buffUTF8,0,sizeof(buffUTF8));
		if (-1 == l2e(lpszStr,buffUTF8))
		{
			strItem = lpszStr;
		}
		else
		{
			strItem = buffUTF8;
		}

		EraseChar(strItem,'\n');
		EraseChar(strItem,'\r');
		
		std::vector<float>::iterator iter;
		for (iter = vctfPos.begin() ;iter != vctfPos.end() ; ++ iter)
		{
			LRCITEM item;
			item.strItem = strItem;
			item.fPos = *iter;
			m_vctLrc.push_back(item);
		}
	}
	if (m_vctLrc.size() > 0)//排序...
	{
		int nSize = m_vctLrc.size();
		for (int i = 0 ;i < nSize ; ++ i)
		{
			for (int j = i+1 ; j < nSize ; ++ j)
			{
				if (m_vctLrc[i].fPos > m_vctLrc[j].fPos)
				{
					LRCITEM item = m_vctLrc[j];
					m_vctLrc[j] = m_vctLrc[i];
					m_vctLrc[i] = item;
				}
			}
		}
	}
	return (m_vctLrc.size()>0);
}

float CLrcMgr::GetPos(const char* lpszStr)
{
	std::string str = lpszStr;
	float fMin = 0.0f;
	float fSec = 0.0f;
	fMin = atof(str.substr(0,2).c_str());
	if (8==strlen(lpszStr))
	{
		fSec = atof(str.substr(3,5).c_str());		
	}
	else if (5==strlen(lpszStr))
	{
		fSec = atof(str.substr(3,4).c_str());	
	}
	return (fMin*60.0f+fSec);
}

int CLrcMgr::GetIndex(float fPos)
{
	int nSize = m_vctLrc.size();
	int nIndex = nSize-1;
	for (int i = 0; i < nSize; ++i)
	{
		if (m_vctLrc[i].fPos > fPos)
		{
			nIndex = i-1;
			break;
		}
	}
	if (nIndex < 0)
	{
		nIndex = 0;
	}
	return nIndex;
}

std::string CLrcMgr::GetStr(int nIndex)
{
	std::string strRet;
	int nMid = m_nHight/2;
	int nTmp;
	int nSize = m_vctLrc.size();
	for (int i = 0 ; i < m_nHight ; ++ i)
	{
		nTmp = nIndex - nMid + i;
		if (nTmp >= 0 && nTmp < nSize)
		{
			strRet += m_vctLrc[nTmp].strItem;
		}
		strRet += "\n";
	}
	return strRet;
}

void CLrcMgr::SetHight(int nH)
{
	m_nHight = nH;
}

bool CLrcMgr::IsEmpty()
{
	return (m_vctLrc.size() > 0?false:true);
}
