#include "PlayerMgr.h"

CPlayerMgr::CPlayerMgr()
{
	m_bRun = true;
	m_bMOLock = false;

	if (0==opendir(getpath(0)))
	{
		mkdir(getpath(0),0777);
	}

	if ((mkfifo(getpath(FIFO_MPLAYER_INPUT), FIFOMODE) < 0) && (errno != EEXIST))
	{
		return;
	}
	if ((mkfifo(getpath(FIFO_MPLAYER_OUTPUT), FIFOMODE) < 0) && (errno != EEXIST))
	{
		return;
	}

	if (-1==access(getpath(ERR_OUTPUT),0))
	{
		FILE* pf = fopen(getpath(ERR_OUTPUT),"w");
		if (pf)
		{
			fclose(pf);
		}
	}

	if (-1==access(getpath(SCRIPT_PATH),0))
	{
		FILE* pf = fopen(getpath(SCRIPT_PATH),"w");
		if (pf)
		{
			fprintf(pf, "#/bin/bash\n");
			fprintf(pf, "#auto generate by CMMusic\n");
			fprintf(pf, "chmod 777 %s\n", getpath(FIFO_MPLAYER_INPUT));
			fprintf(pf, "chmod 777 %s\n", getpath(FIFO_MPLAYER_OUTPUT));
			fprintf(pf, "chmod 777 %s\n", getpath(ERR_OUTPUT));
			fprintf(pf, "pkill -9 mplayer\n");
			fprintf(pf, "pkill -9 gmplayer\n");
			fprintf(
					pf,
					"mplayer -vo x11 -zoom -quiet -slave -idle -input file=$1 > $2 2> %s &\n", 
					getpath(ERR_OUTPUT));
			fclose(pf);
		}
	}

	char szCmd[256];
	sprintf(szCmd, "sh %s %s %s", getpath(SCRIPT_PATH), 
	getpath(FIFO_MPLAYER_INPUT), getpath(FIFO_MPLAYER_OUTPUT));
	system(szCmd);

	thr_id = pthread_create(&p_thread, 0, MpayerOutputProc, this);
}

CPlayerMgr::~CPlayerMgr()
{
	MPlayerCommand("quit\n");
	m_bRun = false;
	while (m_bMOLock)
	{
		usleep(200*1000);
	}
}

void* CPlayerMgr::MpayerOutputProc(void* pData)
{
	if (!pData)
	{
		return 0;
	}
	CPlayerMgr* pMgr = (CPlayerMgr*)pData;
	pMgr->m_bMOLock = true;
	int fdr;
	if ((fdr = open(getpath(FIFO_MPLAYER_OUTPUT), READMODE)) < 0)
	{
	}
	else
	{
		char cRead[2048];
		while (pMgr->m_bRun)
		{
			memset(cRead, 0, sizeof(cRead));
			int readnum;
			if ((readnum = read(fdr, cRead, sizeof(cRead))) < 0)
			{
				if (errno == EAGAIN)
				{
				}
			}
			if (readnum != 0)
			{
				pMgr->ParseOutput(cRead);
			}
		}
		close(fdr);
	}
	pMgr->m_bMOLock = false;
	return 0;
}

void CPlayerMgr::MPlayerCommand(const char* lpszStr, ...)
{
	if (!m_bRun)
	{
		return;
	}
	va_list arg;
	va_start(arg, lpszStr);
	int bufsize = vsnprintf(NULL, 0, lpszStr, arg);
	if (bufsize == -1)
	{
		bufsize = 2048;
	}
	else
	{
		bufsize += 2;
	}
	char* buf = new char[bufsize];
	vsnprintf(buf, bufsize, lpszStr, arg);
	std::string s(buf);
	delete[] buf;
	va_end(arg);
	int fdw;
	if ((fdw = open(getpath(FIFO_MPLAYER_INPUT), WRITEMODE)) < 0)
	{
		//error
		SendMgrMsg(MSG_QUIT,0,0);
	}
	else
	{
		int nwrite;
		if ((nwrite = write(fdw, s.c_str(), s.length())) < 0)
		{
			if (errno == EAGAIN)
			{
			}
		}
		else
		{
		}
		close(fdw);
	}
}

int CPlayerMgr::OnMsg(const char* lpszMsg, WPARAM wParam, LPARAM lParam)
{
	//	log("CPlayerMgr::OnMsg >> %s\n",lpszMsg);
	if (0==strcmp(lpszMsg, MSG_PLAY))
	{
		MPlayerCommand("pause\n");
	}
	else if (0==strcmp(lpszMsg, MSG_STOP))
	{
		MPlayerCommand("pausing seek 0 2\n");
	}
	else if (0==strcmp(lpszMsg, MSG_VOLUM))
	{
		if (lParam)
		{
			int nVolume = (int)lParam;
			MPlayerCommand("volume %d 1\n", nVolume);
		}
	}
	else if (0==strcmp(lpszMsg, MSG_SETPOS))
	{
		if (lParam)
		{
			int nPos = (int)lParam;
			MPlayerCommand("seek %d 1\n", nPos);
		}
	}
	else if (0== strcmp(lpszMsg, MSG_TPOS))
	{
		MPlayerCommand("pausing_keep get_time_pos\n");
	}
	else if (0== strcmp(lpszMsg, MSG_FILE))
	{
		MPlayerCommand("loadfile \'%s\'\n", (char*)lParam);
		MPlayerCommand("pausing_keep volume %d 1\n", (int)wParam);
		MPlayerCommand("pausing_keep get_file_name\n");
		usleep(500*1000);
		MPlayerCommand("pausing_keep get_audio_bitrate\n");
		MPlayerCommand("pausing_keep get_audio_samples\n");
		MPlayerCommand("pausing_keep get_time_length\n");
	}
	else if (0== strcmp(lpszMsg, MSG_URL))
	{
		if (lParam)
		{
			const char* lpszStr = (const char*)lParam;
			if (strlen(lpszStr)>0)
			{
				MPlayerCommand("loadfile \'%s\'\n", lpszStr);
			}
			else
			{
				MPlayerCommand("pausing_keep volume %d 1\n", (int)wParam);
				MPlayerCommand("pausing_keep get_file_name\n");
				usleep(500*1000);
				MPlayerCommand("pausing_keep get_audio_bitrate\n");
				MPlayerCommand("pausing_keep get_audio_samples\n");
				MPlayerCommand("pausing_keep get_time_length\n");
			}
		}
	}
	else if (0== strcmp(lpszMsg, MSG_MUTE))
	{
		MPlayerCommand("mute\n");
	}
	else if (0== strcmp(lpszMsg, MSG_CHAR))
	{
		int* pChar = (int*)lParam;
		if (IsAvalibleKey(*pChar))
		{
			MPlayerCommand("key_down_event %d\n", *pChar);
		}
	}
	else if (0 == strcmp(lpszMsg, MSG_STRCMD))
	{
		if (lParam)
		{
			MPlayerCommand("%s\n", (char*)lParam);
		}
	}
	return 0;
}

bool CPlayerMgr::IsAvalibleKey(int nChar)
{
	bool bRet = false;
	char szTmp[8];
	sprintf(szTmp, "|%c|", nChar);
	std::string str= VMPLAYER_KEY;
	if (std::string::npos != str.find(szTmp))
	{
		bRet = true;
	}
	return bRet;
}

void CPlayerMgr::ParseOutput(const char* lpszStr)
{
	std::string str;
	size_t nPos;
	str = lpszStr;
	if ((nPos = str.find(ANS_TPOS))!= std::string::npos)
	{
		str = lpszStr + nPos;
		str = str.substr(sizeof(ANS_TPOS), str.find('\n')-sizeof(ANS_TPOS));
		float fPer = atof(str.c_str());
		SendMgrMsg(MSG_TPOS,0,(LPARAM)&fPer);
	}
	str = lpszStr;
	if ((nPos = str.find(ANS_TLEN))!= std::string::npos)
	{
		str = lpszStr + nPos;
		str = str.substr(sizeof(ANS_TLEN), str.find('\n')-sizeof(ANS_TLEN));
		float fPer = atof(str.c_str());
		SendMgrMsg(MSG_NAME,3,(LPARAM)&fPer);
	}
	str = lpszStr;
	if ((nPos = str.find(ANS_NAME))!= std::string::npos)
	{
		str = lpszStr + nPos;
		str = str.substr(sizeof(ANS_NAME)+1, str.find('\n')-sizeof(ANS_NAME)-2);
		SendMgrMsg(MSG_NAME,0,(LPARAM)str.c_str());
	}
	str = lpszStr;
	if ((nPos = str.find(ANS_SAMPLES))!= std::string::npos)
	{
		str = lpszStr + nPos;
		str = str.substr(sizeof(ANS_SAMPLES)+1, str.find('\n')
				-sizeof(ANS_SAMPLES)-2);
		SendMgrMsg(MSG_NAME,1,(LPARAM)str.c_str());
	}
	str = lpszStr;
	if ((nPos = str.find(ANS_BITRATE))!= std::string::npos)
	{
		str = lpszStr + nPos;
		str = str.substr(sizeof(ANS_BITRATE)+1, str.find('\n')
				-sizeof(ANS_BITRATE)-2);
		SendMgrMsg(MSG_NAME,2,(LPARAM)str.c_str());
	}
	str = lpszStr;
	if ((nPos = str.find(MSG_NOTIFY))!= std::string::npos)
	{
		if (str.at(nPos-1)=='[' && str.at(nPos+strlen(MSG_NOTIFY))==']')
		{
			std::string strType;
			std::string strParam;
			size_t LPos = str.find('<');
			size_t RPos = str.find('>');
			if (RPos > LPos && LPos != std::string::npos && LPos
					!= std::string::npos)
			{
				strType = str.substr(LPos+1,RPos-LPos-1).c_str();
				LPos = str.find('<', RPos+1);
				RPos = str.find('>', RPos+1);
				if (RPos > LPos && LPos != std::string::npos && LPos
						!= std::string::npos)
				{
					strParam = str.substr(LPos+1,RPos-LPos-1).c_str();
				}
			}
			SendMgrMsg(MSG_NOTIFY, (WPARAM)strType.c_str(), (LPARAM)strParam.c_str());
		}
	}
}
