#include "CurseUI.h"
#include <cstring>
#include <cstdlib>

CCurseUI::CCurseUI()
{
	m_palFrame = 0;
}

CCurseUI::~CCurseUI()
{
	Output();
}

void CCurseUI::SetParam(const char* lpszArg, const char* lpszData)
{
	if (0 == strcmp(lpszArg, "title"))
	{
		m_strTitle = lpszData;
	}
}

void CCurseUI::DoModel()
{
	setlocale(LC_ALL, "");
	initscr();
	//	cbreak();
	//	noecho();
	//	curs_set(0);

	Layout();
	update_panels();
	doupdate();

	DoProccess();

	endwin();
}

void CCurseUI::DoProccess()
{
	keypad(stdscr, TRUE);
	mousemask(ALL_MOUSE_EVENTS, NULL);

	getch();
}

void CCurseUI::Layout()
{
	WINDOW *wins;
	wins = newwin(LINES, COLS, 0, 0);
	box(wins, 0, 0);
	mvwhline(wins,1, 1, '=', COLS-2);
	mvwaddstr(wins, 1, 1, m_strTitle.c_str());
	if (m_palFrame)
	{
		replace_panel(m_palFrame, wins);
		delwin(m_winFrame);
	}
	else
	{
		m_palFrame = new_panel(wins);
	}
	m_winFrame=wins;

}

void CCurseUI::Output()
{
	const char* lpszFile = GetPath("curseui.output").c_str();
	FILE* pf = fopen(lpszFile, "w");
	if (pf)
	{
		if (!m_strOutput.empty())
		{
			fprintf(pf, "%s", m_strOutput.c_str());
		}
		fclose(pf);
	}
}

std::string CCurseUI::GetPath(const char* lpszFile)
{
	if (m_strAppPath.empty())
	{
		m_strAppPath = getenv("HOME");
		m_strAppPath += APP_DIR;
	}
	std::string strRet = m_strAppPath;
	if (lpszFile)
	{
		strRet += lpszFile;
	}
	return strRet;
}
