#include "ListDlg.h"
#include <cstring>
#include <cstdlib>

CListDlg::CListDlg()
{
	m_menu = 0;
	m_meuOption = 0;
}

CListDlg::~CListDlg()
{
}

void CListDlg::DoProccess()
{
	cbreak();
	noecho();
	curs_set(0);
	keypad(stdscr, TRUE);
	int ch = 0;
	bool bOK = false;
	bool bNext = true;
	do
	{
		bOK = false;
		bNext = true;
		do
		{
			ch = getch();
			switch (ch)
			{
			case 27://exit
			{
				bNext = false;
			}
			case 10://enter
			{
				bOK = true;
			}
				break;
			case KEY_UP:
			{
				DriveMenu(m_menu, REQ_UP_ITEM);
			}
				break;
			case KEY_DOWN:
			{
				DriveMenu(m_menu, REQ_DOWN_ITEM);
			}
				break;
			case KEY_PPAGE:
			{
				DriveMenu(m_menu, REQ_SCR_UPAGE);
			}
				break;
			case KEY_NPAGE:
			{
				DriveMenu(m_menu, REQ_SCR_DPAGE);
			}
				break;
			case KEY_LEFT:
			{
				DriveMenu(m_meuOption, REQ_LEFT_ITEM);
			}
				break;
			case KEY_RIGHT:
			{
				DriveMenu(m_meuOption, REQ_RIGHT_ITEM);
			}
				break;
			default:
			{
			}
				break;
			}
		} while (!bOK);
		if (ch == 10)
		{
			int nIndex = -1;
			if (m_menu)
			{
				nIndex = item_index(current_item(m_menu)) + 1;
				char szTmp[16];
				sprintf(szTmp, "%d", nIndex);
				m_strOutput = szTmp;
			}
			if (m_meuOption)
			{
				nIndex = item_index(current_item(m_meuOption)) + 1;
				char szTmp[16];
				sprintf(szTmp, "%d", nIndex);
				m_strOutput += " ";
				m_strOutput += szTmp;
			}
			bNext = false;
		}
	} while (bNext);

}

void CListDlg::DriveMenu(MENU *menu, int nType)
{
	if (menu)
	{
		menu_driver(menu, nType);
		wrefresh(m_winFrame);
	}

}

void CListDlg::Layout()
{
	CCurseUI::Layout();
	// caption
	if (!m_strCaption.empty())
	{
		mvwaddstr(m_winFrame, 2, 1, m_strCaption.c_str());
	}
	//list menu
	int nSize = 0;
	nSize = m_vctList.size();
	if (nSize <= 0)
	{
		return;
	}
	m_items = (ITEM **)calloc(nSize+1, sizeof(ITEM *));
	for (int i = 0; i < nSize; ++i)
	{
		m_items[i] = new_item(m_vctList[i].c_str(), NULL);
	}
	m_items[nSize] = new_item(NULL, NULL);
	m_menu = new_menu((ITEM **)m_items);
	set_menu_win(m_menu, m_winFrame);
	set_menu_sub(m_menu, derwin(m_winFrame, LINES-6, COLS-2, 3, 1));
	set_menu_format(m_menu, LINES-6, 1);
	post_menu(m_menu);
	//option menu
	nSize = m_vctOption.size();
	if (nSize <= 0)
	{
		return;
	}
	m_itmOption = (ITEM **)calloc(nSize+1, sizeof(ITEM *));
	for (int i = 0; i < nSize; ++i)
	{
		m_itmOption[i] = new_item(m_vctOption[i].c_str(), NULL);
	}
	m_itmOption[nSize] = new_item(NULL, NULL);
	m_meuOption = new_menu((ITEM **)m_itmOption);
	set_menu_win(m_meuOption, m_winFrame);
	set_menu_sub(m_meuOption, derwin(m_winFrame, 1, COLS-4, LINES-2, 2));
	set_menu_format(m_meuOption, 1, nSize);
	post_menu(m_meuOption);
}

void CListDlg::SetParam(const char* lpszArg, const char* lpszData)
{
	if (!lpszArg || !lpszData)
	{
		return;
	}
	CCurseUI::SetParam(lpszArg, lpszData);
	if (0 == strcmp(lpszArg, "text"))
	{
		std::string strFile = lpszData;
		if (strFile.empty())
		{
			return;
		}
		std::string strTmp;
		std::ifstream infile(strFile.c_str());
		while (getline(infile, strTmp))
		{
			if (m_strCaption.empty())
			{
				m_strCaption = strTmp;
			}
			else
			{
				m_vctList.push_back(strTmp);
			}
		}
	}
	else if (0 == strcmp(lpszArg, "option"))
	{
		std::string strTmp = lpszData;
		size_t nPos = 0;
		size_t nStart = 0;
		do
		{
			nPos = strTmp.find('|', nStart);
			if (nPos > nStart)
			{
				m_vctOption.push_back(strTmp.substr(nStart, nPos - nStart));
			}
			nStart = nPos + 1;
		} while (nPos != std::string::npos);
	}
}
